#include "ex.h"

Context*
newContext()
{
    return new Context();
}

void
deleteContext(Context* cx)
{
    if (cx)
        delete cx;              // [sic]
}

int
doBar(ContextNonnull cx)        // type error; extern receiving nonnull type
{
    return 1 + cx->foo;
}

static ContextNonnull
Whoops_Cast(Context* cx)
{
    return cx;                  // type error: improperly annotated cast
}

static int
doFooInternal(ContextNonnull cx)
{
    return cx->foo;
}

int
doFoo(Context* cx)
{
    doFooInternal(0);           // type error

    doFooInternal(cx);          // type error

    ContextNonnull cxnn = 0;
    cxnn = cx;                  // type error

    cxnn = Whoops_Cast(cx);     // type error in Whoops_Cast()

    cxnn = CONTEXTNONNULL_CAST(cx); // OK

    doFooInternal(cxnn);        // OK

    cxnn = 0;                   // type error

    ContextNonnull cxnn2;
    cxnn = cxnn2;               // uninitialized value warning

    Context* blah;
    blah = newContext();
    return doFooInternal(blah); // still a type error
}
